using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SqlServer.Management.Smo;
using Microsoft.SqlServer.Management.Common;
using System.Data;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Data.SqlClient;
using System.Threading;
using System.Diagnostics;
using System.Collections;
using ICSharpCode.SharpZipLib.Zip;
using ICSharpCode.SharpZipLib.Core;
using System.Net.Mail;




namespace mssql_br
{
    class report:raznoe
    {
        private DirectoryInfo dir;
        private FileInfo[] file;
        
        public void file_report()
        {
            dir = new DirectoryInfo(conf[4].ToString());
            string reports = "";
            try
            {
                file = dir.GetFiles();
                foreach (FileInfo files in file)
                {

                    reports = reports + files.LastAccessTime + " " + files.Name + "\n";
                }
            }
            catch (Exception e)
            {
                smtp(e.Message.ToString() + "\n");
                
            }

            smtp(reports);

        }

        protected void smtp(string reports)
        {
            string[] eml;
            int i;
            eml = conf[9].ToString().Split(' ');
            for (i = 0; i < eml.Length; i++)
            {

                string server = conf[5].ToString();
                string msg_from = conf[8].ToString();
                string smtp_login = conf[6].ToString();
                string smtp_pass = conf[7].ToString();
                string msg_to = eml[i];
                string msg_subj = "backup_mssql_report";


                MailMessage message = new MailMessage(msg_from, msg_to, msg_subj, reports);
                SmtpClient client = new SmtpClient(server, 25);
                client.Credentials = new System.Net.NetworkCredential(smtp_login, smtp_pass);
                try
                {
                    client.Send(message);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                    Console.ReadLine();
                }

            }
        }

    }
    class raznoe
    {
        protected ArrayList conf;
        public ArrayList db;
        public string j_week;
        private string[] buf;
       
        private void date_week()
        {
            ArrayList week = new ArrayList();
            string[] tmp;
            int i;
            week.Add("Monday=1");
            week.Add("Tuesday=2");
            week.Add("Wednesday=3");
            week.Add("Thursday=4");
            week.Add("Friday=5");
            week.Add("Saturday=6");
            week.Add("Sunday=7");
            for (i = 0; i < week.Count; i++)
            {
                tmp = week[i].ToString().Split('=');
                if (tmp[0] == DateTime.Now.DayOfWeek.ToString())
                {
                    j_week = tmp[1];
                    break;
                }
            }


        }
        public void parse()
        {
            try
            {
                buf = File.ReadAllLines(@"bakup_mssql.conf", Encoding.UTF8);
                conf = new ArrayList();
                string[] tmp;


                foreach (string s in buf)
                {
                    tmp = s.Split('=');
                    if (tmp[0] == "mssql_server")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "mssql_login")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "mssql_passwd")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "path")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "dst_zip")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "smtp_server")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "smtp_login")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "smtp_passwd")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "smtp_from")
                    {
                        conf.Add(tmp[1]);
                    }
                    if (tmp[0] == "smtp_to")
                    {
                        conf.Add(tmp[1]);
                    }

                }
            }
            catch (Exception e)
            {
                
                Console.WriteLine(e.Message.ToString());
                Console.ReadLine();
                Environment.Exit(0);

            }

            try
            {
                buf = File.ReadAllLines(@"db.conf", Encoding.UTF8);
                db = new ArrayList();
                          

                foreach (string s in buf)
                {
                    db.Add(s);
                }
                date_week();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message.ToString());
                Console.ReadLine();
                Environment.Exit(0);
                
            }

            
        }

       
    }
    
   
    class backup_mssql:report
    {
        private Server srvSql;
        private ServerConnection srvConn;
        private Backup bkpDatabase;
        private ZipFile fzip;
        private string base_db;
        private int j;

        public void copy_konst(string base_db,int j)
        {
            this.base_db = base_db;
            this.j = j;
            connect();
        }

               
        private void connect()
        {
            srvConn = new ServerConnection();
            srvConn.LoginSecure = false;
            srvConn.Login = conf[1].ToString();
            srvConn.Password = conf[2].ToString();
            srvConn.ServerInstance = conf[0].ToString();
            
            
            try
            {
                srvSql = new Server(srvConn);
                
            }
            catch (Exception e)
            {
                smtp(e.Message.ToString()+"\n");
                Environment.Exit(0);
                
            }

            backup();              
        }

        private void backup()
        {
            bkpDatabase = new Backup();
            bkpDatabase.Action = BackupActionType.Database;
            bkpDatabase.Database = db[j].ToString();
            BackupDeviceItem bkpDevice = new BackupDeviceItem(conf[3].ToString() + base_db + ".bak", DeviceType.File);
            bkpDatabase.Devices.Add(bkpDevice);
            try
            {
                bkpDatabase.SqlBackup(srvSql);
                compress();
            }
            catch (Exception e)
            {
                smtp(e.Message.ToString()+"\n"+db[j].ToString()+" = base unowkn or nedostupna");
            }


        }
        private void compress()
        {

            fzip = ZipFile.Create(conf[3].ToString() + base_db + ".zip");
            fzip.BeginUpdate();
            fzip.Add(conf[3].ToString() + base_db + ".bak");
            fzip.CommitUpdate();
            fzip.Close();
            file_oper();

        }

        private void file_oper()
        {
           File.Delete(conf[3].ToString() + base_db + ".bak");
           File.Copy(conf[3].ToString() + base_db + ".zip", conf[4].ToString() + base_db + ".zip",true);  
           File.Delete(conf[3].ToString() + base_db + ".zip");
            
        }

    }

    
    class Program
    {
        
        static void Main(string[] args)
        {
            
            string base_db;
            int j;
            backup_mssql tmp = new backup_mssql();
            tmp.parse();
            backup_mssql[] backup = new backup_mssql[tmp.db.Count];
            
            

            for (j = 0; j < tmp.db.Count; j++)
            {
                backup[j] = new backup_mssql();
                backup[j].parse();
                base_db = backup[j].db[j].ToString() + "_" + backup[j].j_week;
                backup[j].copy_konst(base_db, j);
                                            
            }
           tmp.file_report();
            
            
                 
            
        }
    }
    }
